ideal
p186
jumps
model	tiny
include	"tinylib.asi"
; 
macro	addcrc
	add	bx,ax
	adc	bx,1
	adc	bx,0FFFFh
endm
; 
DIRECTBIOS=0			;  ⠭  INT 13h
MAXS=76				; ᨬ쭮 ᫮ ᯮ祭 ᥪ஢
MAXTS=3700			; ᨬ쭮 ᫮ 頥 ᥪ஢
codeseg
startupcode
	jmp	main
; 
drive	db	'@'
count	db	0
active	db	0
chang	db	0
vsects	dw	0
hds1	db	0
scts1	db	0,0
first	dw	0
last	dw	0
int13h:	cmp	[cs:active],0
	jz	@@i1
	cmp	dl,[cs:drive]
	jnz	@@i1
	cmp	ah,2
	jnz	@@i2
	push	ax bx cx dx si di bp
	mov	bp,sp
	mov	al,ch
	mul	[cs:hds1]
	add	al,dh
	adc	ah,0
	mul	[word cs:scts1]
	add	al,cl
	adc	ah,0
	dec	ax
	mov	[cs:first],ax
	add	al,[bp+12]
	adc	ah,0
	mov	[cs:last],ax
	mov	bx,80h
@@q1:	mov	[byte cs:bx],0FFh
	inc	bx
	cmp	bx,0A0h
	jbe	@@q1
	mov	si,offset recov
@@q3:	segcs
	lodsw
	cmp	ax,[cs:first]
	jb	@@q2
	cmp	ax,[cs:last]
	jae	@@q2
	mov	[byte cs:0A0h],0
	sub	ax,[cs:first]
	mov	bx,ax
	lea	ax,[si+@startup-100h-recov-2]
	mov	[cs:bx+80h],al
@@q2:	cmp	si,[cs:vsects]
	jb	@@q3
	cmp	[byte cs:0A0h],0FFh
	jnz	@@a0
	pop	bp di si dx cx bx ax
	pushf
	call	[dword cs:oi13]
	jc	@@y2
	mov	[cs:chang],0
	jmp	@@y2
;	
@@i1:	db	0EAh
oi13	dw	?,?
;	
@@i2:	cmp	ah,16h
	jnz	@@i1
	pushf
	call	[dword cs:oi13]
	cmp	ah,6
	jnz	@@y1
	mov	[cs:active],0
	jmp	@@y2
;	
@@y1:	mov	ah,[cs:chang]
	mov	[cs:chang],6
	cmp	ah,0
	jz	@@y2
	mov	ah,6
	stc
@@y2:	push	bp ax
	mov	bp,sp
	lahf
	mov	[bp+8],ah
	pop	ax bp
	iret
;	
@@a0:	cmp	[cs:chang],6
	jnz	@@r1
	mov	[cs:chang],0
@@r1:	mov	si,offset 80h
	mov	bx,[bp+10]
	mov	cx,[bp+8]
	mov	dx,[bp+6]
	mov	al,[bp+12]
	mov	[cs:count],al
@@a2a:	mov	ax,200h
@@a2:	cmp	[byte cs:si],0FFh
	jnz	@@a1
	inc	al
	dec	[cs:count]
	jz	@@a1
	inc	si
	jmp	@@a2
;	
@@a1:	and	al,al
	jz	@@a3
	mov	[cs:0B0h],al
	pushf
	call	[dword cs:oi13]
	jc	@@err
	mov	ah,[cs:0B0h]
	add	cl,ah
	mov	al,0
	shl	ax,1
	add	bx,ax
@@a3:	cmp	[cs:count],0
	jz	@@ex
	mov	ah,[cs:si]
	mov	al,0
	add	ax,[cs:vsects]
	mov	di,ax
	mov	[byte cs:0B0h],0
@@a4:	mov	ax,[cs:di]
	mov	[es:bx],ax
	inc	di
	inc	di
	inc	bx
	inc	bx
	dec	[byte cs:0B0h]
	jnz	@@a4
	inc	cl
	inc	si
	dec	[cs:count]
	jnz	@@a2a
@@ex:	mov	[byte bp+13],0
	clc
	jmp	@@a5
;	
@@err:	mov	[bp+12],ax
@@a5:	lahf
	mov	[bp+18],ah
@@ir:	pop	bp di si dx cx bx ax
	iret
; 
int2f:	cmp	ax,0FE67h
	jnz	@@m1
	cmp	bx,'DR'
	jnz	@@m1
	cmp	cx,'$#'
	jnz	@@m1
	cmp	dx,12345
	jnz	@@m1
	mov	ax,'OK'
	mov	bx,cs
	iret
@@m1:	db	0EAh
oi2f	dw	?,?
recov:
; 
proc	rdblk	near
	;int	3
	push	es cs
	pop	es
	mov	[tsct],0
	push	di
	xor	ax,ax
	mov	di,offset goodmap
	mov	[tptr],di
	mov	cx,50
	rep	stosw
	pop	di
	mov	bp,buflen/512
	mov	bx,offset buffer
	cmp	[hdc],-1
	jz	@@m1
@@m0:	cmp	bp,[sects]
	jb	@@m1
	cmp	[timeout],0
	jnz	@@m1

	mov	al,[byte sects]
	mov	ch,[trkc]
	mov	cl,1
	mov	dh,[hdc]
	mov	dl,[drive]
	and	[cs:gmmod],0FDh
	call	schk
	jc	@@m6
	
	mov	ah,2
	int	13h
	jnc	@@m5
@@m6:	push	bx bp
@@m4a:	call	chrd
	mov	al,2
	jc	@@m7
	mov	ax,201h
	call	int13
	jnc	@@m4
	mov	al,1
@@m7:	push	di
	mov	di,[tptr]
	mov	[byte di],al
;	inc	di
;	mov	[tptr],di
	pop	di
@@m4:	inc	[tptr]
	add	bx,200h
	inc	cl
	cmp	cl,[byte sects]
	jbe	@@m4a
	pop	bp bx
	jmp	@@m5a
;	
@@m5:	mov	ax,[sects]
	add	[tptr],ax
@@m5a:	sub	bp,[sects]
	mov	ah,[byte sects]
	add	[tsct],ah
	add	[byte rds],ah
	adc	[byte rds+1],0
	mov	al,0
	shl	ax,1
	add	bx,ax
	mov	al,[hdc]
	inc	al
	mov	[hdc],al
	cmp	al,[byte heads]
	jb	@@m2
	mov	[hdc],0
	mov	al,[trkc]
	inc	al
	mov	[trkc],al
	cmp	al,[byte trks]
	jae	@@m3
@@m2:	jmp	@@m0
;	
@@m3:	mov	[hdc],-1
@@m1:	pop	es
	ret
endp
; 
proc	schk
	push	si cx dx
	mov	cl,al
	cmp	[cs:gmmod],0
	jnz	@@sc1
	mov	dl,[cs:gmbit]
	mov	si,[cs:gmptr]
	xor	ch,ch
	jcxz	@@sc1
@@sc3:	test	[cs:si],dl
	stc
	jnz	@@sc2
	rol	dl,1
	adc	si,0
	loop	@@sc3
	mov	[cs:gmptr],si
	mov	[cs:gmbit],dl
	or	[cs:gmmod],2
@@sc2:
@@sc1:	;clc
	pop	dx cx si
	ret
endp
; 
proc	chrd
	push	si ax
	cmp	[cs:gmmod],0
	jnz	@@ci1
	mov	al,[cs:gmbit]
	mov	si,[cs:gmptr]
	test	[cs:si],al
	lahf
	rol	al,1
	adc	si,0
	mov	[cs:gmptr],si
	mov	[cs:gmbit],al
	sahf
	jz	@@ci1
	stc
@@ci1:	pop	ax si
	ret
endp
; 
proc	crc2gm
	;int	3
	mov	si,offset crcs
	mov	di,offset badmap
	mov	cx,256
	xor	ax,ax
	push	di
	rep	stosw
	pop	di
	mov	dl,1
	mov	[gmptr],di
	mov	[gmbit],dl
	mov	cx,[ts]
@@cr2:	lodsw
	inc	ax
	jnz	@@cr1
	or	[di],dl
@@cr1:	rol	dl,1
	adc	di,0
	loop	@@cr2
	mov	[gmmod],0
	ret
endp
; 
proc	escchk	near
	push	es
	xor	ax,ax
	mov	es,ax
	mov	[byte es:440h],182
	pop	es
	inkey
	jz	@@m1
	getkey
	dec	ah
	jnz	@@m1
@@m2:	stc
	ret
;	
@@m1:	cmp	[timeout],0
	jnz	@@m2
	clc
	ret
endp
; 
;proc	rnd	near
macro	rnd
	push	ax
	mov	ax,[seed]
	shl	ax,4
	add	ax,[seed]
	add	ax,9279
	mov	[seed],ax
	pop	ax
endm
;	ret
;endp
; 
proc	build	near
	;int	3
	call	form1
	jnc	@@y1
@@2:	mov	ax,-1
	ret
;	
@@y1:	;int	3
	call	gbadmap
	cmp	[more80],0
	jz	@@y1a
	string	'This disk contain more than '
	intpri	[rtrk]
	string	' cylinders'
	mov	di,offset badmap
	;int	3
	mov	al,[byte heads]
	mul	[byte sects]
	mov	ah,[byte rtrk]
	mul	ah
	mov	[newts],ax
	mov	dx,[ts]
	sub	dx,ax
	mov	cl,al
	and	cl,7
	shr	ax,3
	add	di,ax
	mov	al,1
	shl	al,cl
	mov	cx,dx
@@y1c:	test	[di],al
	jz	@@y1b
	rol	al,1
	adc	di,0
	loop	@@y1c
	string	'. Resize to '
	mov	ax,[newts]
	shr	ax,1
	intpri	ax
	string	' K ?(Y/N)'
	call	yesno
	jc	@@2
	mov	ax,[rtrk]
	mov	[trks],ax
	mov	ax,[newts]
	mov	[ts],ax
	mov	bx,offset bootbuf
	cmp	[word bx+13h],0
	jz	@@3
	mov	[word bx+13h],ax
	jmp	@@4
;	
@@3:	mov	[word bx+20h],ax
@@4:	mov	ax,301h
	mov	cx,1
	mov	dh,0
	mov	dl,[drive]
	call	int13
	jnc	@@y1a
	cmp	ah,3
	jnz	@@1
	string	<'Disk is write-protected',13,10>
	jmp	@@2
;	
@@y1b:	string	<' - can''t build recovery record',13,10>
	jmp	@@2
;	
@@1:	string	<'Write error',13,10>
	jmp	@@2
;	
@@y1a:	mov	[gmptr],offset badmap
	mov	[gmbit],1
	mov	[gmmod],0
	mov	[sector],0
	mov	[seed],1234h
	mov	[trkc],0
	mov	[hdc],0
	mov	[rds],0
	mov	[badsc],0
	mov	[skipsc],0
	
	mov	es,[mseg]
	xor	di,di
	mov	cx,7E00h
	xor	ax,ax
	rep	stosw
	mov	es,[tseg]
@@m8:	call	rdblk
	mov	cl,[tsct]
	mov	ch,0
	jcxz	@@m1
	mov	si,offset buffer
	mov	[tptr],offset goodmap
@@m2:	push	cx si
;   ᥪ ⠥ CRC
	mov	bx,[tptr]
	mov	al,[bx]
	and	al,al
	jz	@@m4a
	cmp	al,2
	jz	@@m2a
	inc	[badsc]
@@m2a:	inc	[skipsc]
	mov	bx,-1
	jmp	@@m4b
;	
@@m4a:	xor	bx,bx
	mov	cx,100h
@@m4:	lodsw
	addcrc
@@m3:	loop	@@m4
@@m4b:	mov	ax,[sector]
	add	ax,ax
	xchg	ax,bx
	mov	[crcs+bx],ax
	pop	si
	inc	[tptr]
	inc	ax
	jz	@@m9a
	xor	di,di
	mov	cx,[_maxs]
@@m6:	push	si cx
	rnd
	mov	cx,200h
@@m5:	lodsb
	mov	bl,al
	mov	bh,[byte seed]
	xor	bh,[byte seed+1]
	mov	al,[es:bx]
	xor	[ss:di],al
	inc	di
	loop	@@m5
	add	di,MAXS
	pop	cx si
	loop	@@m6
@@m9a:	add	si,200h
	inc	[sector]
	pop	cx
	string	<13,'Reading: '>
	mov	ax,[sector]
	shr	ax,1
	intpri	ax
	string	' K, Bad/Skipped sectors: '
	intpri	[badsc]
	string	'/'
	intpri	[skipsc]
	call	escchk
	jnc	@@e1
	string	<13,10,'Terminated',13,10>
	mov	ax,-2
	ret
;	
@@e1:	loop	@@m2
	jmp	@@m8
;	
@@m1:	string	<' - done',13,10>
	xor	ax,ax
	ret
endp
; 
proc	recover	near
	push	cs
	pop	es
	call	crc2gm
	mov	[ts],0
	mov	[seed],1234h
	mov	[dc],0
	mov	di,offset busy
	mov	cx,MAXS
	xor	ax,ax
	rep	stosb
	mov	es,[tseg]
@@m8:	call	rdblk
	mov	cl,[tsct]
	mov	ch,0
	jcxz	@@m1
	mov	si,offset buffer
	mov	[tptr],offset goodmap
@@m2:	push	cx
	push	si
	xor	bx,bx
	mov	cx,100h
@@m4:	lodsw
	addcrc
	loop	@@m4
	mov	ax,[ts]
	add	ax,ax
	xchg	ax,bx
	pop	si
	cmp	[crcs+bx],-1
	jz	@@m11
	push	bx
	mov	bx,[tptr]
	cmp	[byte bx],0
	pop	bx
	jnz	@@m4a
	cmp	ax,[crcs+bx]
	jz	@@m10
@@m4a:	mov	bx,[dc]
	lea	ax,[bx+1]
	mov	[dc],ax
	cmp	ax,[_maxs]
	jbe	@@m12
	string	<13,10,'Too many sectors damaged - cannot recover',13,10>
	pop	cx
	mov	ax,-1
	ret
;	
@@m1:	mov	ax,[dc]
	and	ax,ax
	jnz	@@n1
	string	<13,10,'No errors found',13,10>
	xor	ax,ax
	ret
;	
@@n1:	string	<13,10>
	intpri	ax
	string	<' sector(s) damaged - '>
	mov	bp,[dc]
@@n9:	mov	cx,[_maxs]
	xor	si,si
	mov	bx,offset busy
@@n4:	cmp	[byte bx],0
	jnz	@@n4a
	cmp	[byte ss:si+bp+511],0
	jnz	@@n3
@@n4a:	inc	bx
	add	si,MAXS+512
	loop	@@n4
	string	<'cannot recover',13,10>
	mov	ax,-1
	ret
;	
@@n3:	mov	[byte bx],1
	mov	di,bp
	mov	[ds:cross+bp+di-2],si
	
	mov	al,[ss:si+bp+511]
	mov	bx,offset xm1
	xlat
	mov	bl,al
	push	si bp
	lea	bp,[bp+511]
@@p3:	mov	bh,[ss:si+bp]
	mov	al,[es:bx]
	mov	[ss:si+bp],al
	dec	bp
	jns	@@p3
	pop	bp si

	mov	cx,[_maxs]
	xor	di,di
@@n8:	cmp	si,di
	jz	@@n6
	lea	bx,[bp+511]
	
	mov	al,[ss:di+bx]
	mov	[tmp3],al
@@p4:	mov	al,[tmp3]
	mov	ah,[ss:si+bx]
	xchg	ax,bx
	mov	bl,[es:bx]
	xchg	ax,bx
	xor	[ss:di+bx],al
	dec	bx
	jns	@@p4
@@n6:	add	di,MAXS+512
	loop	@@n8
	dec	bp
	jnz	@@n9
	mov	cx,[dc]
	xor	di,di
@@w1:	push	cx
	mov	si,[cross+di]
	xor	bx,bx
	mov	cx,100h
@@w4:	segss
	lodsw
	addcrc
	loop	@@w4
	mov	si,[damaged+di]
	add	si,si
	cmp	bx,[crcs+si]
	jnz	@@w2
	inc	di
	inc	di
	pop	cx
	loop	@@w1
	string	<'data recovered',13,10>
	mov	ax,1
	ret
;	
@@w2:	pop	cx
	string	<'data not recovered',13,10>
	mov	ax,-1
	ret
;	
@@m12:	mov	di,bx
	mov	ax,[ts]
	mov	[damaged+bx+di],ax
	mov	cx,[_maxs]
	add	bx,512
@@m13:	rnd
	mov	al,[byte seed]
	xor	al,[byte seed+1]
	mov	[ss:bx],al
	add	bx,MAXS+512
	loop	@@m13
	jmp	@@m11
;	
@@m10:	xor	di,di
	mov	cx,[_maxs]
@@m6:	push	si cx
	rnd
	mov	cx,200h
@@m5:	lodsb
	mov	bl,al
	mov	bh,[byte seed]
	xor	bh,[byte seed+1]
	mov	al,[es:bx]
	xor	[ss:di],al
	inc	di
	loop	@@m5
	add	di,MAXS
	pop	cx si
	loop	@@m6
@@m11:	add	si,200h
	inc	[tptr]
	inc	[ts]
	pop	cx
	string	<13,'Reading: '>
	mov	ax,[ts]
	shr	ax,1
	intpri	ax
	string	' K, errors: '
	intpri	[dc]
	call	escchk
	jnc	@@e1
	string	<13,10,'Terminated',13,10>
	mov	ax,-2
	ret
;	
@@e1:	loop	@@m2
	jmp	@@m8
endp
; 
proc	rrwrite	near
	string	'Writting recovery record... '
	push	cs
	pop	es
	mov	dl,[drive]
	mov	dh,0
	mov	cl,1
	mov	ch,[byte rtrk]
	mov	bx,offset header
	mov	ax,301h
	call	dwrite
	jc	@@w3
	mov	bx,offset crcs
	inc	cl
	mov	al,[byte crcss]
	mov	ah,3
	call	dwrite
	jc	@@w3
	push	[_maxs]
	pop	[tmp4]
	xor	bx,bx
	mov	es,[mseg]
	add	cl,[byte byte crcss]
@@w1:	mov	ax,301h
	call	dwrite
	jc	@@w3
	add	bx,512+MAXS
	dec	[tmp4]
	jz	@@w2
	inc	cl
	cmp	cl,[byte sects]
	jbe	@@w1
	mov	cl,1
	inc	dh
	cmp	dh,[byte heads]
	jb	@@w1
	mov	dh,0
	inc	ch
	jmp	@@w1
;	
@@w2:	string	<'done',13,10>
	ret
;	
@@w3:	string	<'write error',13,10>
	ret
endp
; 
proc	dwrite	near
	push	ax
	call	int13
	pop	ax
	jc	@@m1
	mov	ah,2
	push	es bx ax cs
	pop	es
	mov	bx,offset buffer
	call	int13
	pop	ax bx es
	jc	@@m1
	push	cx si di
	mov	ch,al
	xor	cl,cl
	mov	di,bx
	mov	si,offset buffer
	rep	cmpsw
	pop	di si cx
	jz	@@m1
	stc
@@m1:	ret
endp
; 
proc	int13	near
	push	bp
	mov	bp,3
@@m0:	push	ax
	int	13h
	jnc	@@m1
	cmp	ah,80h
	jnz	@@m2
	mov	[timeout],1
	mov	bp,1
@@m2:	pop	ax
	dec	bp
	jnz	@@m0
	pop	bp
	ret
;	
@@m1:	pop	ax bp
	ret
endp
; 
proc	rrread	near
	push	es cs
	pop	es
	mov	dh,0
	mov	dl,[drive]
	mov	cx,40*256+1
	mov	bx,offset buffer
	mov	ax,201h
	call	int13
	jc	@@m1
	call	@@chk
	jz	@@m2
	mov	cx,80*256+1
	mov	ax,201h
	call	int13
	call	@@chk
	jnz	@@m3
@@m2:	push	cx
	mov	si,offset buffer
	mov	di,offset header
	mov	cx,100h
	rep	movsw
	pop	cx
	string	'Reading data recovery record... '
	inc	cl
	mov	ax,[sector]
	mov	[ts],ax
	add	ax,255
	mov	al,ah
	mov	ah,0
	cbw
	inc	ax
	mov	[tmp4],ax
	dec	ax
	mov	ah,2
	mov	bx,offset crcs
	call	int13
	jc	@@m1
	mov	ax,[sects]
	mul	[heads]
	cmp	ch,80
	jnz	@@m4
	add	ax,ax
@@m4:	sub	ax,[tmp4]
	xchg	[tmp4],ax
	dec	al
	add	cl,al
	mov	es,[mseg]
	xor	bx,bx
@@m6:	mov	ax,201h
	mov	dl,[drive]
	call	int13
	jc	@@m1
	add	bx,512+MAXS
	dec	[tmp4]
	jz	@@m5
	inc	cl
	cmp	cl,[byte sects]
	jbe	@@m6
	mov	cl,1
	inc	dh
	cmp	dh,[byte heads]
	jb	@@m6
	mov	dh,0
	inc	ch
	jmp	@@m6
;	
@@m5:	pop	es
	string	<'done',13,10>
	clc
	ret
;	
@@m3:	string	<'Recovery record not found',13,10>
	jmp	@@err
;	
@@chk:	push	cx
	mov	si,offset header
	mov	cx,hlen
	mov	di,offset buffer
	rep	cmpsb
	pop	cx
	ret
;	
@@m1:	string	<'Read error',13,10>
@@err:	stc
	pop	es
	ret
endp
; 
proc	form1	near
	call	trkslc
	jnc	@@m1
	string	<'Invalid disk format',13,10>
	ret
;	
@@m1:	xor	ax,ax
	mov	es,ax
	lds	si,[es:78h]
	push	si ds
	mov	di,offset dpt
	mov	[es:78h],di
	mov	[es:7Ah],cs
	push	cs
	pop	es
	mov	cx,11
	rep	movsb
	push	cs
	pop	ds
	mov	bx,offset buffer
	mov	ax,201h
	mov	ch,[byte rtrk]
	mov	cl,1
	mov	dh,0
	mov	dl,[drive]
	call	int13
	jc	@@1
	mov	si,offset buffer
	mov	di,offset header
	mov	cx,hlen
	repz	cmpsb
	jnz	@@mm
@@mx:	string	'Erase old recovery record?(Y/N)'
	call	yesno
	jnc	@@mm
	jmp	@@ex1
;	
@@1:	cmp	[noform],0
	jz	@@5
	jmp	@@m5a
;	
@@mm:	cmp	[noform],0
	jz	@@5
	mov	bx,offset bootbuf
	mov	ax,301h
	mov	ch,[byte rtrk]
	mov	cl,1
	mov	dh,0
	mov	dl,[drive]
	call	int13
	jc	@@6
	jmp	@@ex
;	
@@5:	mov	ah,18h
	mov	ch,[byte rtrk]
	inc	ch
	mov	cl,[byte sects]
	mov	[byte dpt+4],cl
	mov	dl,[drive]
	mov	al,cl
	int	13h
	push	cs
	pop	es
	mov	dl,[drive]
	mov	ch,[byte rtrk]
@@m2a:	mov	dh,0
@@m2:	mov	bp,5
	mov	[byte dpt+7],40h
	mov	[byte dpt+5],20h
@@m2e:	xor	bx,bx
	mov	al,1
	mov	ah,[byte sects]
	shl	ah,2
@@m2b:	mov	[byte formbuf+bx],ch
	mov	[byte formbuf+bx+1],dh
	mov	[byte formbuf+bx+2],al
	mov	[byte formbuf+bx+3],2
	add	bx,8
	cmp	bl,ah
	jb	@@m2c
	mov	bx,4
@@m2c:	inc	al
	cmp	al,[byte sects]
	jbe	@@m2b
	mov	bx,offset formbuf
	mov	cl,[byte sects]
	mov	al,cl
	mov	ah,5
	int	13h
	jnc	@@m4
@@m5:	shr	[byte dpt+5],1
	shr	[byte dpt+7],1
	dec	bp
	jnz	@@m2e
@@6:	cmp	ah,3
	jnz	@@m5a
	string	<'Disk is write-protected',13,10>
@@ex1:	stc
@@ex:	mov	ax,0
	mov	es,ax
	pop	[es:7Ah] [es:78h]
	mov	es,[tseg]
	ret
;	
@@m5a:	string	<'Disk error',13,10>
	stc
	jmp	@@ex
;	
@@m4:	mov	ah,4
	mov	cl,1
	mov	al,[byte sects]
	int	13h
	jc	@@m5
	inc	dh
	cmp	dh,[byte heads]
	jb	@@m2
	cmp	ch,40
	jz	@@m3
	inc	ch
	cmp	ch,81
	jbe	@@m2a
@@m3:	clc
	jmp	@@ex
endp
; 
proc	trkslc	near
	mov	ax,[ts]
	add	ax,255
	mov	al,ah
	mov	ah,0
	mov	[more80],ah
	cbw
	inc	ax
	mov	cx,ax
	mov	ax,[sects]
	mul	[heads]
	mov	bx,ax
	mov	ax,[trks]
	cmp	ax,80
	jbe	@@1
;	cmp	ax,82
;	jne	@@m1
	mov	[more80],1
	jmp	@@m2
;	
@@1:	cmp	ax,50
	jae	@@m2
	cmp	ax,40
	jbe	@@2
;	cmp	ax,41
;	jne	@@m1
	mov	[more80],1
@@2:	mov	[rtrk],40
@@m3a:	sub	bx,cx
	cmp	bx,MAXS
	jbe	@@m4
	mov	bx,MAXS
@@m4:	mov	[_maxs],bx
	dec	cx
	mov	[crcss],cx
	clc
	ret
;	
@@m2:	mov	[rtrk],80
	add	bx,bx
	jmp	@@m3a
;	
@@m1:	stc
	ret
endp
; 
proc	fix	near
	;int	3
	push	ss
	pop	es
	mov	cx,[dc]
	xor	si,si
@@m1:	push	cx
	mov	ax,[damaged+si]
	xor	dx,dx
	div	[sects]
	inc	dx
	push	dx
	xor	dx,dx
	div	[heads]
	push	dx
	mov	ch,al
	pop	bx
	mov	dh,bl
	pop	bx
	mov	cl,bl
	mov	dl,[drive]
	mov	bx,[cross+si]
;	add	bx,offset matrix
	mov	ax,301h
	call	int13
	jc	@@m2
	inc	si
	inc	si
	pop	cx
	loop	@@m1
	ret
;	
@@m2:	string	<'Write error',13,10>
	ret
;	
endp
; 
proc	altfix	near
	mov	[es:active],2
	mov	si,offset recov
	mov	di,[es:vsects]
@@m1:	mov	ax,[es:si]
	xor	dx,dx
	div	[word es:scts1]
	inc	dx
	push	dx
	div	[byte es:hds1]
	mov	ch,al
	mov	dh,ah
	pop	bx
	mov	cl,bl
	mov	dl,[es:drive]
	mov	bx,di
	mov	ax,301h
	call	int13
	jc	@@m2
	inc	si
	inc	si
	add	di,200h
	cmp	si,[es:vsects]
	jb	@@m1
	mov	[es:active],0
	ret
;	
@@m2:	string	<'Write error',13,10>
	mov	[es:active],1
	ret
endp
; 
proc	getdpb	near
	push	cs
	pop	es
	mov	si,3
	cmp	[ffix],0
	jnz	@@m0
	mov	ah,0
	mov	al,[fcyls]
	mov	[trks],ax
	mov	al,[fsids]
	mov	[heads],ax
	mov	al,[fscts]
	mov	[sects],ax
	jmp	@@m4
;	
@@m0:	mov	ax,201h
	mov	cx,1
	mov	bx,offset bootbuf
	mov	dl,[drive]
	mov	dh,0
	int	13h
	jnc	@@m1
	dec	si
	jnz	@@m0
	mov	al,1
	ret
;	
@@m1:	mov	al,2
	cmp	[word bootbuf+1FEh],0AA55h
	jnz	@@m2
	cmp	[word bootbuf+0Bh],200h
	jnz	@@m2
	mov	cx,[bootbuf+18h]
	mov	dl,[fscts]
	xor	dh,dh
	mov	[sects],cx
	test	[ffix],1
	jnz	@@m1a
	mov	[sects],dx
@@m1a:	mov	ax,[bootbuf+1Ah]
	mov	dl,[fsids]
	mov	[heads],ax
	test	[ffix],2
	jnz	@@m1b
	mov	[heads],dx
@@m1b:	mul	cx
	mov	cx,ax
	xor	dx,dx
	mov	ax,[bootbuf+13h]
	and	ax,ax
	jnz	@@m3
	mov	ax,[bootbuf+20h]
	mov	dx,[bootbuf+22h]
@@m3:	mov	[ts],ax
	div	cx
	mov	[trks],ax
	xor	ah,ah
	mov	al,[fcyls]
	test	[ffix],4
	jnz	@@m1c
	mov	[trks],ax
@@m1c:	test	[ffix],8
	jnz	@@m1d
@@m4:	mov	al,[byte heads]
	mul	[byte sects]
	mul	[word trks]
	mov	[ts],ax
@@m1d:	mov	al,1
	and	dx,dx
	jnz	@@m2
	ret
;	
@@m2:	stc
	ret
endp
; 
proc	gbadmap
	;int	3
	cld
	push	cs
	pop	es
	mov	di,offset badmap
	mov	cx,256
	xor	ax,ax
	rep	stosw
	cmp	[ffix],15
	jz	@@gb1
@@gb0:	ret
;	
@@gb1:	mov	cx,[bootbuf+0Eh]
	mov	ax,[bootbuf+16h]
	mov	bx,ax
	add	bx,cx
	cmp	bx,[sects]
	ja	@@gb0
	mov	ah,2
	mov	bx,offset buffer
	mov	dh,0
	mov	dl,[drive]
	inc	cl
	call	int13
	jc	@@gb0
	mov	di,offset badmap
	mov	si,offset buffer+3
	mov	al,[byte bootbuf+10h]
	mul	[byte bootbuf+16h]
	mov	dx,[bootbuf+11h]
	shr	dx,4
	add	ax,dx
	add	ax,[bootbuf+0Eh]
	push	ax
	mov	cl,al
	and	cl,7
	mov	bl,1
	shl	bl,cl
	shr	ax,3
	add	di,ax
	mov	ax,[ts]
	pop	dx
	sub	ax,dx
	mov	cl,[byte bootbuf+0Dh]
	and	cx,0FFh
	jnz	@@gb3
	mov	cx,1
@@gb3:	xor	dx,dx
	mov	bh,cl
	div	cx
	mov	cx,ax
	jcxz	@@gb0
@@gb8:	lodsb
	mov	ah,[si]
	and	ax,0FFFh
	jnz	@@gb9a
	cmp	[su],0
	jz	@@gb9b
@@gb9a:	cmp	ax,0FF7h
@@gb9b:	mov	al,bl
	jz	@@gb4
	xor	al,al
@@gb4:	mov	ah,bh
@@gb7:	or	[di],al
	rol	al,1
	rol	bl,1
	adc	di,0
	dec	ah
	jnz	@@gb7
	loop	@@gb5
	ret
;	
@@gb5:	lodsw
	shr	ax,4
	and	ax,ax
	jnz	@@gb9c
	cmp	[su],0
	jz	@@gb9d
@@gb9c:	cmp	ax,0FF7h
@@gb9d:	mov	al,bl
	jz	@@gb6
	xor	al,al
@@gb6:	mov	ah,bh
@@gb9:	or	[di],al
	rol	al,1
	rol	bl,1
	adc	di,0
	dec	ah
	jnz	@@gb9
	loop	@@gb8
	ret
endp
; 
proc	outform	near
	string	'Format '
	mov	ax,[ts]
	shr	ax,1
	intpri	ax
	string	' K :  '
	intpri	[trks]
	string	' tracks, '
	intpri	[heads]
	string	' side(s), '
	intpri	[sects]
	string	<' sectors',13,10>
	ret
endp
; 
proc	chkdsk	near
	string	'Checking disk '
	mov	al,[drive]
	add	al,'A'
	mov	ah,0Eh
	int	10h
	string	<':',13,10>
	ret
endp
; 
proc	instchk	near
	mov	ax,0FE67h
	mov	bx,'DR'
	mov	cx,'$#'
	mov	dx,12345
	int	2Fh
	cmp	ax,'OK'
	ret
endp
; 
proc	getsave	near
	string	<13,10,'Save recovered data to disk?(Y/N)'>
	jmp	yesno
endp
; 
proc	yesno
	mov	al,'y'
	cmp	[yes],1
	jz	@@y
@@0:	getkey
	cmp	ah,1
	jz	@@n
	and	al,0DFh
	cmp	al,'Y'
	jz	@@y
	cmp	ah,15h
	jz	@@y
	cmp	al,'N'
	jz	@@n
	cmp	ah,31h
	jnz	@@0
@@n:	stc
@@y:	pushf
	push	ax
	mov	ah,0Eh
	int	10h
	string	<13,10>
	pop	ax
	popf
	ret
endp
; 
proc	gmaxs
	cli
	mov	al,90h
	out	70h,al
	jcxz	$+2
	jcxz	$+2
	jcxz	$+2
	jcxz	$+2
	in	al,71h
	sti
	cmp	[drive],0
	jnz	@@1
	shr	al,4
@@1:	and	al,0Fh
	mov	bx,offset tmax
	xlat
	ret
endp
; 
main:	mov	ax,cs
	add	ax,1000h
	mov	[mseg],ax
	cli
	xor	bx,bx
	mov	ss,ax
	mov	sp,bx
	push	bx
	sti
	add	ax,1000h
	mov	[tseg],ax
	add	ax,1000h
	cmp	ax,[2]
	jbe	@@m2a
	string	<'Not enough memory',13,10>
	ret
@@m2a:	mov	es,[tseg]		;   GF(256)
	xor	bx,bx
@@z3:	xor	dx,dx
	mov	cl,bl
	mov	al,bh
	xor	ah,ah
	rept	8
	local	@@z1
	shr	cl,1
	jnc	@@z1
	xor	dx,ax
@@z1:	shl	ax,1
	endm
	irpc	rl,76543210
	local	@@z2
	test	dx,(100h SHL rl)
	jz	@@z2
	xor	dx,(11Bh SHL rl)
@@z2:
	endm
	mov	[es:bx],dl
	cmp	dl,1
	jnz	@@z4
	mov	si,bx
	and	si,0FFh
	mov	[xm1+si],bh
@@z4:	inc	bx
	jnz	@@z3
	
	string	<'Disk Recover Utility V 2.06. Copyright (c) Programmist X',13,10,13,10>
	mov	[timeout],0
	cld
	cmdline
	 cmdarg	@yes,"/Y"
	 cmdarg	@cki,"/C"
	 cmdarg	@cks,"/F"
	 cmdarg	@rem,"/R"
	 cmdarg	@rem,"/U"
	 cmdarg	@dpb,"/DP"
	 cmdarg	@su,"/SU"
	 cmdarg	@drA,"A:"
	 cmdarg	@drB,"B:"
	 cmdarg	@drA,"0"
	 cmdarg	@drB,"1"
	cmdarg
	mov	al,[fun]
	cbw
	add	ax,ax
	mov	bx,ax
	jmp	[funs+bx]
;	
@yes:	mov	[yes],1
	ret
@su:	mov	[su],1
	ret
@cki:	mov	[fun],3
	ret
@cks:	mov	[fun],2
	ret
@rem:	mov	[fun],4
	ret
@drA:	mov	[drive],0
@drAA:	mov	al,[fun]
	sub	al,1
	adc	al,1
	mov	[fun],al
	ret
@drB:	mov	[drive],1
	jmp	@drAA
;	
extrn	_cmdptr:word
@dpb:	and	[ffix],7
	mov	si,[_cmdptr]
	lodsb
	cmp	al,':'
	jnz	@@dp1
	mov	[_cmdptr],si
	getint	ax
	test	ax,7FFFh
	jz	@@dp6
	cmp	ax,40
	jbe	@@dp2
	cmp	ax,50
	jb	@@dp3
	cmp	ax,80
	jbe	@@dp2
@@dp3:	mov	al,40
@@dp2:	mov	[fcyls],al
	and	[ffix],3
@@dp6:	mov	si,[_cmdptr]
	lodsb
	cmp	al,':'
	jnz	@@dp1
	mov	[_cmdptr],si
	getint	ax
	test	ax,7FFFh
	jz	@@dp7
	cmp	ax,2
	ja	@@dp1
	mov	[fsids],al
	and	[ffix],5
@@dp7:	mov	si,[_cmdptr]
	lodsb
	cmp	al,':'
	jnz	@@dp1
	mov	[_cmdptr],si
	getint	ax
	test	ax,7FFFh
	jz	@@dp1
	cmp	ax,21
	jb	@@dp5
	mov	al,21
@@dp5:	mov	[fscts],al
	and	[ffix],6
@@dp1:	ret
;	
@help:	string
	db	'USAGE:',13,10
	db	' dr [/SU | /DP:[cyls]:[heads]:[sects]] drive:',13,10
	db	'  Create and write recovery record',13,10
	db	'  /SU - check unused space',13,10
	db	'  /DP:[cyls]:[heads]:[sects] - set disk parameters and ignore FAT-info',13,10,13,10
	db	' dr /[F | C] drive:',13,10
	db	'  Check and recover disk in drive',13,10
	db	'  /C  - check disk and install to memory',13,10
	db	'  /F  - check disk and write recovered data',13,10,13,10
	db	' dr /[R | U] ',13,10
	db	'  Remove Disk Recover from memory',13,10
	db	0
	ret
;	
@remov:	call	instchk
	jz	@@r1
	string	<'Disk Recover is not installed',13,10>
	ret
;	
@@r1:	mov	[cs:tmp5],bx

	mov	ax,352Fh
	int	21h
	cmp	bx,offset int2F
	jnz	@cant
	mov	ax,es
	cmp	ax,[cs:tmp5]
	jnz	@cant
	

IF DIRECTBIOS
	mov	es,[cs:tmp5]
	mov	[tmp],0
	lds	dx,[dword es:oi13]
	mov	[cs:tmp2],dx
	mov	[cs:tmp4],ds
	mov	ah,13h
	int	2Fh

	cli
	cmp	dx,offset int13h
	jnz	@@r2
	mov	ax,ds
	cmp	ax,[cs:tmp5]
	jnz	@@r2
	mov	dx,[cs:tmp2]
	mov	ds,[cs:tmp4]
	jmp	@@r2a
;	
@@r2:	mov	[cs:tmp],1
@@r2a:	mov	ah,13h
	int	2Fh
	sti
	cmp	[cs:tmp],0
	jnz	@cant
ELSE
	mov	ax,3513h
	int	21h
	cmp	bx,offset int13h
	jnz	@cant
	mov	ax,es
	cmp	ax,[cs:tmp5]
	jnz	@cant
	lds	dx,[dword es:oi13]
	mov	ax,2513h
	int	21h
ENDIF
@@r3:	mov	ds,[cs:tmp5]
	lds	dx,[dword oi2f]
	mov	ax,252Fh
	int	21h
	;int	3
	mov	ds,[cs:tmp5]
	mov	es,[2Ch]
	mov	ah,49h
	int	21h
	push	ds
	pop	es
	mov	ah,49h
	int	21h
	string	<'Disk Recover is removed from memory',13,10>
	ret
;	
@cant:	string	<'Cannot remove from memory',13,10>
	ret
;	
@error:	string	<'???',13,10>
	ret
;	
proc	@build	near
	cmp	[drive],1
	ja	@error
	call	getdpb
	jc	@error
	mov	[noform],0
	;int	3
	call	gmaxs
	cmp	al,[byte sects]
	adc	[noform],0
	call	outform
	string	<'Building recovery record...',13,10>
	call	build
	and	ax,ax
	jnz	@@m1
	call	rrwrite
@@m1:	ret
endp
;	
proc	@fix	near
	call	instchk
	jnz	@@x1
	mov	es,bx
	mov	al,[drive]
	cmp	al,[es:drive]
	jnz	@@x1
	cmp	[es:active],0
	jz	@@x1
	call	getsave
	jc	@@m0
	call	altfix
@@m0:	ret
;	
@@x1:	call	rrread
	jc	@@m1
	call	outform
	call	chkdsk
	call	recover
	dec	ax
	jnz	@@m1
	call	getsave
	jc	@@m1
	call	fix
@@m1:	ret
endp
;	
proc	@check	near
	call	rrread
	jc	@@m2
	call	outform
	call	chkdsk
	call	recover
	dec	ax
	jnz	@@m2
	call	instchk
	jz	@@t2
	mov	[active],0FFh
	push	cs
	pop	es
	mov	si,offset install
	mov	di,offset crcs
	mov	cx,INSLEN/2
	rep	movsw
	jmp	near crcs
;	
@@t2:	mov	es,bx
	mov	[active],0
;	
install:mov	al,[byte cs:heads]
	mov	[es:hds1],al
	mov	al,[byte cs:sects]
	mov	[es:scts1],al
	mov	al,[cs:drive]
	mov	[es:drive],al
	mov	di,offset recov
	mov	si,offset damaged
	mov	cx,[cs:dc]
	mov	dx,cx
	rep	movsw
	mov	ds,[cs:mseg]
	mov	[es:vsects],di
	xor	bx,bx
@@m1:	mov	si,[cs:cross+bx]
	mov	cx,256
	rep	movsw
	inc	bx
	inc	bx
	dec	dx
	jnz	@@m1
	mov	[es:chang],1
	mov	ah,1
	xchg	[es:active],ah
	
	xor	cx,cx
	mov	es,cx
	mov	cl,[cs:drive]
	mov	al,1
	and	cl,al
	shl	al,cl
	or	[es:43Eh],al	
	inc	ah
	jnz	@@m2
;	int	3
	push	cs
	pop	ds
IF DIRECTBIOS
	mov	ah,13h
	mov	dx,offset int13h
	int	2Fh
	mov	[cs:oi13],dx
	mov	[cs:oi13+2],ds
	push	cs
	pop	ds
	mov	dx,offset int13h
	mov	ah,13h
	int	2Fh
	push	cs
	pop	ds
ELSE
	mov	ax,3513h
	int	21h
	mov	[oi13],bx
	mov	[oi13+2],es
	mov	dx,offset int13h
	mov	ax,2513h
	int	21h
ENDIF
	mov	ax,352Fh
	int	21h
	mov	[oi2f],bx
	mov	[oi2f+2],es
	mov	dx,offset int2f
	mov	ax,252Fh
	int	21h
	
	call	@@m2
	
;	mov	ah,16h
;	int	13h
;	mov	dl,[cs:drive]
;	mov	ax,0401h
;	mov	cx,1
;	mov	dh,0
;	int	13h
	
	mov	dx,offset recov+MAXS*514
	int	27h
@@m2:	mov	ah,0
	int	13h

	ret
INSLEN	=	$+1-install
endp
; 
dataseg
tmax	db	0,10,18,10,21,0,0,0,0,0,0,0,0,0,0,9
yes	db	0
noform	db	0
more80	db	0
fun	db	0
timeout	db	0
fcyls	db	0
fsids	db	0
fscts	db	0
su	db	0
ffix	db	15
gmptr	dw	0
gmbit	db	0
gmmod	db	1
tsct	db	?
tmp	db	?
tmp3	db	?
trkc	db	?
hdc	db	?
dpt	db	11 dup (?)
busy	db	MAXS dup (?)

align	2
funs	dw	@help,@build,@fix,@check,@remov
header	db	'DR2.0',0,'Copyright (c) Programmist X',0
hlen	=	$-header
_maxs	dw	12	;Ŀ
sector	dw	0	;
trks	dw	0
heads	dw	0
sects	dw	0
;carry	=	$
	org	header+512
buffer	dw	24000 dup (?)
buflen	=	$-buffer
bootbuf	dw	256 dup (?)
badmap	dw	256 dup (?)
tptr	dw	?
goodmap	db	100 dup (?)
dc	dw	?
crcss	dw	?
rtrk	dw	?
sigs	dw	?
ts	dw	?
newts	dw	?
;handle	dw	?
mseg	dw	?
tseg	dw	?
seed	dw	?
badsc	dw	?
skipsc	dw	?
rds	dw	?
tmp2	dw	?
tmp4	dw	?
tmp5	dw	?
damaged	dw	MAXS dup (?)
cross	dw	MAXS dup (?)
crcs	dw	MAXTS dup (?)
xm1	db	256 dup (?)
formbuf	db	22*4 dup (?)
	dw	100h dup (?)
;matrix	=	byte es:0
;amatr	=	byte es:8000h
end